{ 2004-03-13 programmeerimisvistluse algajate 3. lesande tester           }
{ lesanne: ELEKTRITOIDE                                                    }
{ Autor: Ahto Truu                                                          }

{$I+}

const
   maxn = 1000;

type
   loik = record
      x1, y1, x2, y2 : integer;
      k : integer;
   end;

var
   n : integer;
   a : array [1..maxn] of loik;
   v : array [1..maxn] of boolean;
   f : text;
   i, k, kk : integer;
   x, y, p : integer;

function kattuvad(a1, a2, b1, b2 : integer) : boolean;
var mina, maxa, minb, maxb : integer;
begin
   if a1 < a2 then mina := a1 else mina := a2;
   if a1 > a2 then maxa := a1 else maxa := a2;
   if b1 < b2 then minb := b1 else minb := b2;
   if b1 > b2 then maxb := b1 else maxb := b2;
   if mina > maxb then exit(false);
   if minb > maxa then exit(false);
   exit(true);
end;

function suund(var l : loik; x, y : integer) : integer;
var dx1, dy1, dx2, dy2, z : longint;
begin
   dx1 := l.x2 - l.x1; dy1 := l.y2 - l.y1;
   dx2 := x - l.x1; dy2 := y - l.y1;
   z := dx1 * dy2 - dy1 * dx2;
   if z < 0 then exit(-1);
   if z > 0 then exit(1);
   exit(0);
end;

function loikuvad(var l1, l2 : loik) : boolean;
var z11, z12, z21, z22 : integer;
begin
   if not kattuvad(l1.x1, l1.x2, l2.x1, l2.x2) then exit(false);
   if not kattuvad(l1.y1, l1.y2, l2.y1, l2.y2) then exit(false);
   z11 := suund(l1, l2.x1, l2.y1);
   z12 := suund(l1, l2.x2, l2.y2);
   z21 := suund(l2, l1.x1, l1.y1);
   z22 := suund(l2, l1.x2, l1.y2);
   exit((z11 * z12 <= 0) and (z21 * z22 <= 0));
end;

procedure margi(i, k : integer);
var j : integer;
begin
   a[i].k := k;
   for j := 1 to n do
      if a[j].k < 0 then
         if loikuvad(a[i], a[j]) then
            margi(j, k);
end;

function otsi(x, y : integer) : integer;
var i : integer;
begin
   for i := 1 to n do begin
      if (a[i].x1 = x) and (a[i].y1 = y) then exit(a[i].k);
      if (a[i].x2 = x) and (a[i].y2 = y) then exit(a[i].k);
   end;
   exit(-1);
end;

begin
   if paramcount <> 2 then begin
      writeln('Sntaks on: ', paramstr(0), ' sisendfail vljundfail');
      halt(1);
   end;

   { loeme sisendandmed }
   assign(f, paramstr(1)); reset(f);
   readln(f, n);
   for i := 1 to n do
      readln(f, a[i].x1, a[i].y1, a[i].x2,a[i].y2);
   close(f);

   { lahendame }
   for i := 1 to n do
      a[i].k := -1;
   k := 0;
   for i := 1 to n do
      if a[i].k < 0 then begin
         k := k + 1;
         margi(i, k);
      end;
   for i := 1 to k do
      v[i] := true;

   { kontrollime vastuse }
   assign(f, paramstr(2)); reset(f);
   if ioresult <> 0 then begin
      writeln('Viga vljundfaili avamisel');
      halt(1);
   end;
   readln(f, kk);
   if ioresult <> 0 then begin
      writeln('Viga vljundfaili lugemisel');
      halt(1);
   end;
   if k <> kk then begin
      writeln('Vale komponentide arv ', kk, ', peaks olema ', k);
      halt(1);
   end;
   for i := 1 to kk do begin
      readln(f, x, y);
      if ioresult <> 0 then begin
         writeln('Viga vljundfaili lugemisel');
         halt(1);
      end;
      p := otsi(x, y);
      if p < 0 then begin
         writeln('Tundmatu punkt ', x, ', ', y);
         halt(1);
      end;
      if not v[p] then begin
         writeln('Korduv komponent ', x, ', ', y);
         halt(1);
      end;
      v[p] := false;
   end;
   close(f);

   writeln('Korras');
end.
