{ 2004-03-13 programmeerimisvistluse edasijunudte 2. lesande lahendus    }
{ lesanne: HULKNURK                                                        }
{ Autor: Ahto Truu                                                          }
{ Testitud: FPC 1.0.10 / Win32                                              }

const
   sisf = 'HN.SIS';                                      { sisendfaili nimi }
   valf = 'HN.VAL';                                     { vljundfaili nimi }

var
   n : longint;                                               { tippude arv }
   x0, y0 : double;                               { keskpunkti koordinaadid }
   x1, y1 : double;                                     { tipu koordinaadid }
   vx, vy : double;                 { vektori (x0,y0)->(x1,y1) koordinaadid }
   r : double;                                     { mberringjoone raadius }
   p, s : double;                                    { mbermt ja pindala }
   f : text;
   i : integer;

begin
   { loeme sisendandmed }
   assign(f, sisf); reset(f);
   readln(f, n);
   readln(f, x0, y0);
   readln(f, x1, y1);
   close(f);

   { arvutame vahetulemused }
   vx := x1 - x0; vy := y1 - y0;
   r := sqrt(sqr(vx) + sqr(vy));
   p := 2 * n * r * sin(pi / n);
   s := n * sqr(r) * sin (pi / n) * cos(pi / n);

   { vljastame tulemuse }
   assign(f, valf); rewrite(f);
   writeln(f, p :0:3);
   writeln(f, s :0:3);
   for i := 0 to n - 1 do begin
      { prame vektorit (x0,y0)->(x1,y1) i/n pret pripeva }
      x1 := x0 + vx * cos(i * 2 * pi / n) + vy * sin(i * 2 * pi / n);
      y1 := y0 + vy * cos(i * 2 * pi / n) - vx * sin(i * 2 * pi / n);
      writeln(f, x1 :0:3, ' ', y1 :0:3);
   end;
   close(f);
end.
