{ 2004-03-13 programmeerimisvistluse algajate 2. lesande lahendus         }
{ lesanne: MUSTKUNSTNIK                                                    }
{ Autor: Ahto Truu                                                          }
{ Testitud: FPC 1.0.10 / Win32                                              }

const
   sisf = 'MK.SIS';                                      { sisendfaili nimi }
   valf = 'MK.VAL';                                     { vljundfaili nimi }
   maxp = 500;                                    { maksimaalne arvu pikkus }

type
   arv = array [0..maxp] of integer;     { andmetp suure arvu esitamiseks }

{ omistab suurele arvule vikese }
procedure omist(var a : arv; x : integer);
var i : integer;
begin
   for i := 0 to maxp do begin
      a[i] := x mod 10;
      x := x div 10;
   end;
end;

{ korrutab suure arvu vikesega }
procedure korr(var a : arv; x : integer);
var i, k : integer;
begin
   k := 0; { lekanne madalamast jrgust }
   for i := 0 to maxp do begin
      k := k + a[i] * x;
      a[i] := k mod 10;
      k := k div 10;
   end;
   { letitumise kontroll }
   if k > 0 then
      writeln('letitumine!');
end;

{ jagab suure arvu vikesega }
procedure jaga(var a : arv; x : integer);
var i, k : integer;
begin
   k := 0; { lekanne krgemast jrgust }
   for i := maxp downto 0 do begin
      k := 10 * k + a[i];
      a[i] := k div x;
      k := k mod x;
   end;
   { jagumise kontroll }
   if k > 0 then
      writeln('Ei jagunud!');
end;

{ vljastab suure arvu faili }
procedure tryki(var f : text; var a : arv);
var i : integer;
begin
   i := maxp;
   while (i > 0) and (a[i] = 0) do
      i := i - 1;
   while i >= 0 do begin
      write(f, a[i]);
      i := i - 1;
   end;
end;

var
   f : text;                          { failimuutuja sisendi-vljundi jaoks }
   n, k : integer;                                           { sisendandmed }
   i : integer;
   a : arv;
begin
   { loeme sisendandmed }
   assign(f, sisf); reset(f);
   readln(f, n, k);
   close(f);

   { lahendame lesande }
   omist(a, 1);
   for i := 1 to n do
      korr(a, i);
   for i := 1 to k do
      jaga(a, i);
   for i := 1 to n - k do
      jaga(a, i);

   { vljastame vastuse }
   assign(f, valf); rewrite(f);
   tryki(f, a); writeln(f);
   close(f);
end.
