{ 2004-03-13 programmeerimisvistluse algajate 2. lesande lahendus         }
{ lesanne: MUSTKUNSTNIK                                                    }
{ Autor: Avo Muromgi                                                       }
{ Testitud: FPC 1.0.10 / Win32                                              }

{
 Antud n ja k. Leida n! / (k! * (n - k)!).
 Kombinatsioonide arv leitakse jrgmiselt:
 k := min(k, n - k)
 (n - k + 1) / 1 * (n - k + 1) / 2 * (n - k + 3) / 3 * ... * n / k

 Jagamisel ei teki, kunagi jki, sest
 1) kahe jrjestiku tisarvu hulgas on alati vhemalt ks, mis jagub 2-ga
 2) kolme jrjestikuse tisarvu hulgas on alati vhemalt ks, mis jagub 3-ga
 3) nelja jrjestikuse tisarvu hulgas on alati vhemalt ks, mis jagub 4-ga
    ja peale selle veel ks, mis jagub 2-ga(aga mitte 4-ga)
 ...
}

const
  sn = 'MK.SIS';
  vn = 'MK.VAL';
  maxl = 61;//maksimaalne vimalik vastuse pikkus
  base = 10;//kasutatav arvussteem

type
  TBigNum = record
    int : array [1..maxl] of integer;//arv ise
    l : integer;//numbrite arv arvus
  end;

procedure readInput(var n, k : integer);
  var
    inf : text;
  begin
    assign(inf, sn);reset(inf);
    readln(inf, n, k);
    close(inf);
  end;

procedure writeOutput(C : TBigNum);
  var
    i : integer;
    outf : text;
  begin
    assign(outf, vn);rewrite(outf);
    for i := C.l downto 1 do
      write(outf, C.int[i]);
    writeln(outf);
    close(outf);
  end;

function multiply(C : TBigNum; a : integer) : TBigNum;
  var
    i : integer;
    x : integer;
  begin
     x := 0;
    for i := 1 to C.l do begin
      inc(x, C.int[i] * a);
      C.int[i] := x mod base;
      x := x div base;
    end;
    while x > 0 do begin
      inc(C.l);
      C.int[C.l] := x mod base;
      x := x div base;
    end;
    multiply := C;
  end;

function divide(C : TBigNum; a : integer) : TBigNum;
  var
    i : integer;
    x : integer;
    result : TBigNum;
  begin
    x := 0;
    result.l := 0;
    for i := C.l downto 1 do begin
      x := x * base + C.int[i];
      if x >= a then begin
        if result.l = 0 then result.l := i;
        result.int[i] := x div a;
        x := x mod a;
      end
      else result.int[i] := 0;
    end;
    divide := result;
  end;

function combinations(n, k : integer) : TBigNum;
  var
    i : integer;
    x : integer;
    C : TBigNum;
  begin
    if n = k then begin
      C.l := 1;
      C.int[C.l] := 1;
    end
    else begin
      if k > n div 2 then k := n - k;
      //seame C vrdseks arvuga n-k+1.
      x := n - k + 1;C.l := 0;
      while x > 0 do begin
        inc(C.l);
        C.int[C.l] := x mod base;
        x := x div base;
      end;
      for i := 2 to k do
        C := divide(multiply(C, n - k + i), i);
    end;
    combinations := C;
  end;

var
  k, n : integer;
begin
  readInput(n, k);
  writeOutput(combinations(n, k));
end.
