/*
Eesti informaatikaolümpiaadi lõppvoor 13.03.2004
Algajad, ülesanne 1: Ridakabe

Näidislahendus, Mihkel Kree

Ruutkeerukusega algoritm.
Lahenduse idee on väga lihtne, iga ruudu jaoks leitakse sealt tehtav pikim käik.
*/

#include <stdio.h>

int n; // mängulaua pikkus
int seis[101000]; // mängulaua seis (NB! indekseerimine algab nullist)
int parim=0; // hetkel teadaolev pikim käik

void sisend(){
  FILE* f;
  f=fopen("RK.SIS","r");
  fscanf(f,"%d",&n);
  for (int i=0; i<n; i++) fscanf(f,"%d",&seis[i]);
}

void leiaparim(){
  // Proovime käike teha esimeselt, teiselt, ... , n-1'selt  ruudult.
  // Viimaselt ruudult ei saaks ju käiku teha.
  for (int i=0; i<n-1; i++){
    int nupp=seis[i];  // antud ruudul oleva nupu kõrgus, millest iga järgnev nupp peab olema madalam
    int loe=0;  // positsioonist i pikima tehtava käigu pikkuse loendur
    // Kuni vaadeldavad nupud on madalamad algpositsiooni nupust.
    while (seis[i+loe+1]<nupp) {
      loe++;
      if (i+loe+1>=n) break; // vältimaks üle massiivi ääre minemist
    }
    if (loe>parim) parim=loe;
  }
}

void valjund(){
  FILE* f;
  f=fopen("RK.VAL","w");
  fprintf(f,"%d\n",parim);
}

int main(){
  sisend();
  leiaparim();
  valjund();
  return 0;
}
