{ 2004-03-13 programmeerimisvistluse algajate 1. lesande lahendus         }
{ lesanne: RIDAKABE                                                        }
{ Autor: Ahto Truu                                                          }
{ Testitud: FPC 1.0.10 / Win32                                              }

{ O(N^2) }

const
   sisf = 'RK.SIS';                                      { sisendfaili nimi }
   valf = 'RK.VAL';                                     { vljundfaili nimi }
   maxn = 100000;                            { maksimaalne mngulaua pikkus }

var
   n : longint;                                          { mngulaua suurus }
   a : array [1..maxn] of longint;                         { mngulaua seis }
   p : longint;                                  { maksimaalne kigu pikkus }
   f : text;
   i : longint;

{ leiab pikima kigu i->k pikkuse }
function pikkus(i : longint) : longint;
var k : longint;
begin
   k := i + 1;
   while (k <= n) and (a[i] > a[k]) do
      k := k + 1;
   { a[k] on esimene, mille peale a[i] kia ei vi }
   exit((k - 1) - i);
end;

begin
   { loeme sisendandmed }
   assign(f, sisf); reset(f);
   readln(f, n);
   for i := 1 to n do
      read(f, a[i]);
   close(f);

   { lahendame lesande }
   p := 0;
   for i := 1 to n do
      if pikkus(i) > p then
         p := pikkus(i);

   { vljastame vastuse }
   assign(f, valf); rewrite(f);
   writeln(f, p);
   close(f);
end.
