{ 2004-03-13 programmeerimisvistluse algajate 3. lesande lahendus         }
{ lesanne: ELEKTRITOIDE                                                    }
{ Autor: Indrek Jentson                                                     }
{ Testitud: FPC 1.0.10 / Win32                                              }

const
  maxN = 1000;

type
  Rada = record
    x1, y1, x2, y2, kontuur : integer;
  end;

var
  rajad : array[1..maxN] of Rada;
  N, K  : integer;

procedure LoeAndmed;
var
  in_file : text;
  i : integer;
begin
  assign(in_file, 'EL.SIS');
  reset(in_file);
  readln(in_file, N);
  for i := 1 to N do
    begin
    readln(in_file, rajad[i].x1, rajad[i].y1, rajad[i].x2, rajad[i].y2);
    rajad[i].kontuur := 0;
    end;
  close(in_file);
  K := 0;
end;

function vk(x1, y1, x2, y2 : LongInt) : Integer; {meid huvitab ainult mrk }
var res : Real;
begin
  res := x1 * y2 - x2 * y1;
  if res > 0 then
    vk := 1
  else if res < 0 then
    vk := -1
  else
    vk := 0;
end;

function min(a, b : integer) : integer;
begin
  if a > b then min := b
  else min := a;
end;

function max(a, b : integer) : integer;
begin
  if a < b then max := b
  else max := a;
end;

function kastis(x, y, x1, y1, x2, y2 : Integer) : boolean;
begin
  kastis := (x >= min(x1, x2)) and (x <= max(x1, x2))
    and (y >= min(y1, y2)) and (y <= max(y1, y2));
end;

function Puutuvad(r1, r2 : Rada) : boolean;
var a, b : integer;
begin
  a := vk(r2.x1-r1.x1, r2.y1-r1.y1, r1.x2-r1.x1, r1.y2-r1.y1) *
       vk(r2.x2-r1.x1, r2.y2-r1.y1, r1.x2-r1.x1, r1.y2-r1.y1);
  b := vk(r1.x1-r2.x1, r1.y1-r2.y1, r2.x2-r2.x1, r2.y2-r2.y1) *
       vk(r1.x2-r2.x1, r1.y2-r2.y1, r2.x2-r2.x1, r2.y2-r2.y1);
  Puutuvad := ((a < 0) and (b < 0)) or ((a < 0) and (b = 0)) or
    ((a = 0) and (b < 0)) or ((a = 0) and (b = 0) and
    (kastis(r1.x1, r1.y1, r2.x1, r2.y1, r2.x2, r2.y2) or
     kastis(r1.x2, r1.y2, r2.x1, r2.y1, r2.x2, r2.y2) or
     kastis(r2.x1, r2.y1, r1.x1, r1.y1, r1.x2, r1.y2) or
     kastis(r2.x2, r2.y2, r1.x1, r1.y1, r1.x2, r1.y2) ));
end;

function LeiaKontuur(p : Integer) : Integer;
var cnt, i : integer;
begin
  rajad[p].kontuur := K;
  cnt := 1;
  for i := 1 to N do
    if rajad[i].kontuur = 0 then
      if Puutuvad(rajad[p], rajad[i]) then
        begin
        cnt := cnt + LeiaKontuur(i);
        end;
  LeiaKontuur := cnt;
end;

procedure Lahenda;
var c, i : Integer;
begin
  c := 0;
  repeat
    inc(K);
    i := 1;
    while rajad[i].kontuur > 0 do inc(i);
    c := c + LeiaKontuur(i);
  until c = N;
end;

procedure KirjutaVastus;
var
  out_file : text;
  i, j : Integer;
  first : boolean;
begin
  assign(out_file, 'EL.VAL');
  rewrite(out_file);
  writeln(out_file, K);
  for i := 1 to K do
    begin
    j := 1;
    while rajad[j].kontuur <> i do inc(j);
    writeln(out_file, rajad[j].x1, ' ', rajad[j].y1);
    end;
  close(out_file);
end;

begin
  LoeAndmed;
  Lahenda;
  KirjutaVastus;
end.
